unit unt_contas_bus;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, Buttons, ExtCtrls, Grids, DBGrids, Mask, DBCtrls;

type
  Tfor_contas_bus = class(TForm)
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    DataSource1: TDataSource;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TMaskEdit;
    DBEdit1: TDBEdit;
    CAD: TButton;
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CADClick(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  for_contas_bus: Tfor_contas_bus;
  tipbus, sitbus : string;

implementation

uses unt_dados;

{$R *.dfm}

procedure Tfor_contas_bus.FormShow(Sender: TObject);
begin
  ComboBox1.Items.Clear;
  Combobox1.Text := 'Buscar por';
  Combobox1.Items.Add('Nome');
  Combobox1.Items.Add('CPF');
  Combobox1.Items.Add('CNPJ');
  edit1.Clear;
  tipbus := 'con_nome like';
  sitbus := '%';
  edit1.SetFocus;
end;

procedure Tfor_contas_bus.ComboBox1Change(Sender: TObject);
begin
  if ComboBox1.Text = 'Nome' then
  begin
    tipbus := 'con_nome like';
    sitbus := '%';
    edit1.Clear;
    edit1.EditMask := '';
    label2.Caption := 'Nome:';
    edit1.SetFocus;
  end;
  if ComboBox1.Text = 'CPF' then
  begin
    tipbus := 'Con_cgccpf = ';
    sitbus := '';
    edit1.Clear;
    edit1.EditMask := '###.###.###-##;1;_';
    label2.Caption := 'CPF:';
    edit1.SetFocus;
  end;
  if ComboBox1.Text = 'CNPJ' then
  begin
    tipbus := 'Con_cgccpf = ';
    sitbus := '';
    edit1.Clear;
    edit1.EditMask := '##.###.###/####-##;1;_';
    label2.Caption := 'CNPJ:';
    edit1.SetFocus;
  end;
end;

procedure Tfor_contas_bus.BitBtn1Click(Sender: TObject);
begin
  with for_dados.que_contas do
  begin
    close;
    sql.Clear;
    sql.Add('select * from contas');
    sql.Add('WHERE '+TIPBUS+'"'+edit1.Text+''+sitbus+'"');
    sql.Add('order by con_cod');
    open;
  end;
  DBGrid1.SetFocus;
end;

procedure Tfor_contas_bus.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then BitBtn1.Click;
end;

procedure Tfor_contas_bus.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  With for_dados do
  begin
    que_contas.Close;
  end;
end;

procedure Tfor_contas_bus.CADClick(Sender: TObject);
begin
  for_dados.tab_contas.Locate('con_cod',dbedit1.Text,[lopartialkey,locaseinsensitive]);
  CLOSE;
end;

procedure Tfor_contas_bus.DBGrid1DblClick(Sender: TObject);
begin
  cad.Click;
end;

procedure Tfor_contas_bus.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
    if key = #13 then cad.Click;
end;

procedure Tfor_contas_bus.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = vk_escape then close;
  if key = vk_f1 then edit1.SetFocus;
end;

end.
