unit unt_desp_lanc;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, DBCtrls, ExtCtrls, DB, Buttons;

type
  Tfor_desp_lanc = class(TForm)
    Panel1: TPanel;
    pmenu: TPanel;
    bavanca: TButton;
    bretornar: TButton;
    binclui: TButton;
    bmodifica: TButton;
    bexclui: TButton;
    Button1: TButton;
    g1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label9: TLabel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    data1: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    GroupBox1: TGroupBox;
    Label11: TLabel;
    Label10: TLabel;
    bsim: TButton;
    bnao: TButton;
    DBEdit4: TDBEdit;
    DataSource1: TDataSource;
    DBEdit7: TDBEdit;
    SpeedButton1: TSpeedButton;
    procedure bincluiClick(Sender: TObject);
    procedure bmodificaClick(Sender: TObject);
    procedure bsimClick(Sender: TObject);
    procedure bnaoClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure DBEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit3Exit(Sender: TObject);
    procedure bavancaClick(Sender: TObject);
    procedure bretornarClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  for_desp_lanc: Tfor_desp_lanc;
  tipdesp, situ : string;

implementation

uses unt_dados, unt_contas;

{$R *.dfm}

procedure Tfor_desp_lanc.bincluiClick(Sender: TObject);
begin
  with for_dados do
  begin
    tab_desp.Insert;
    tab_despdes_situ.Value := 'a';
    tab_despdes_tipo.Value := tipdesp;
    tab_despdes_datlan.Value := date;
    tab_config.Open;
    if tipdesp = 'e' then tab_despdes_cod.Value := tab_configcod_rec.Value + 1;
    if tipdesp = 's' then tab_despdes_cod.Value := tab_configcod_pag.Value + 1;
    tab_config.Close;
  end;
  situ := 'i';
  bsim.Visible := true;
  bnao.Visible := true;
  g1.Enabled := true;
  pmenu.Enabled := false;
  dbedit1.SetFocus;
  label11.Caption := 'Deseja Incluir Cadastro';
end;

procedure Tfor_desp_lanc.bmodificaClick(Sender: TObject);
begin
  for_dados.tab_desp.Edit;
  situ := 'e';
  bsim.Visible := true;
  bnao.Visible := true;
  g1.Enabled := true;
  pmenu.Enabled := false;
  dbedit1.SetFocus;
  label11.Caption := 'Salvar as Alteraoes';
end;

procedure Tfor_desp_lanc.bsimClick(Sender: TObject);
begin
  with for_dados do
  begin
    if situ = 'i' then
    begin
      tab_config.Open;
      tab_config.Edit;
      if tipdesp = 'e' then
      begin
        IF (for_dados.tab_contas.Locate('con_cod',dbedit3.Text,[lopartialkey,locaseinsensitive])) = true then
        begin
          tab_contas.Edit;
          tab_contasCon_credito.Value := tab_contasCon_credito.Value + tab_despdes_valor.Value;
          tab_contas.Post;
        end;
        tab_configcod_rec.Value := tab_configcod_rec.Value + 1;
        tab_despdes_cod.Value := tab_configcod_rec.Value;
      end
      else
      begin
        IF (for_dados.tab_contas.Locate('con_cod',dbedit3.Text,[lopartialkey,locaseinsensitive])) = true then
        begin
          tab_contas.Edit;
          tab_contasCon_debito.Value := tab_contasCon_debito.Value + tab_despdes_valor.Value;
          tab_contas.Post;
        end;
        tab_configcod_pag.Value := tab_configcod_pag.Value + 1;
        tab_despdes_cod.Value := tab_configcod_pag.Value;
      end;
      tab_config.Post;
      tab_config.Close;
    end;
    tab_desp.Post;
  end;
  g1.Enabled := false;
  bsim.Visible := false;
  bnao.Visible := false;
  pmenu.Enabled := true;
  bavanca.SetFocus;
  label11.Caption := 'Tecle ESC para Sair';
end;

procedure Tfor_desp_lanc.bnaoClick(Sender: TObject);
begin
  for_dados.tab_desp.Cancel;
  g1.Enabled := FALSE;
  pmenu.Enabled := true;
  bavanca.SetFocus;
  bsim.Visible := false;
  bnao.Visible := false;
  label11.Caption := 'Tecle ESC para Sair';
end;

procedure Tfor_desp_lanc.Button1Click(Sender: TObject);
begin
  close
end;

procedure Tfor_desp_lanc.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  with for_dados do
  begin
    tab_desp.Close;
    tab_contas.Close;
  end;
end;

procedure Tfor_desp_lanc.FormShow(Sender: TObject);
begin
  with for_dados do
  begin
    tab_desp.Filter := 'des_tipo = '''+tipdesp+'''';
    tab_desp.Open;
  end;
end;

procedure Tfor_desp_lanc.DBEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
  begin
    key := #0;
    Perform(CM_DIALOGKEY,vk_tab,0);
  end;
end;

procedure Tfor_desp_lanc.DBEdit3Exit(Sender: TObject);
begin
  for_dados.tab_contas.Close;
  for_dados.tab_contas.Open;
  if dbedit3.Text <> '' then
  begin
    IF (for_dados.tab_contas.Locate('con_cod',dbedit3.Text,[lopartialkey,locaseinsensitive])) = false then
    begin
      showmessage('Conta no Encontrada');
      dbedit3.Text;
      dbedit3.SetFocus;
    end;
  end
  else
  begin
    SpeedButton1.Click;
  end;
end;

procedure Tfor_desp_lanc.bavancaClick(Sender: TObject);
begin
  with for_dados do
  begin
    tab_desp.Next;
    if tab_desp.Eof then showmessage('Fim, no pode avanar');
  end;
end;

procedure Tfor_desp_lanc.bretornarClick(Sender: TObject);
begin
  with for_Dados do
  begin
    tab_desp.Prior;
    if tab_desp.Bof then showmessage('Inicio, no pode voltar');
  end;
end;

procedure Tfor_desp_lanc.SpeedButton1Click(Sender: TObject);
begin
  for_contas.ShowModal;
end;

end.
