unit unt_desp_parc;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBCtrls, Mask, StdCtrls, Buttons, Grids, DBGrids, DB;

type
  Tfor_desp_parc = class(TForm)
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    BitBtn1: TBitBtn;
    MaskEdit1: TMaskEdit;
    DBEdit1: TDBEdit;
    DataSource1: TDataSource;
    ComboBox1: TComboBox;
    Label2: TLabel;
    Memo1: TMemo;
    b_limpa: TBitBtn;
    procedure Edit6Exit(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MaskEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure b_limpaClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  for_desp_parc: Tfor_desp_parc;
  tiplanc : string;

implementation

uses unt_dados;

{$R *.dfm}

procedure Tfor_desp_parc.Edit6Exit(Sender: TObject);
begin
  for_dados.tab_contas.Open;
  if (for_dados.tab_contas.Locate('con_cod',edit6.Text,[lopartialkey,locaseinsensitive])) = false then
  begin
    showmessage ('Conta no encontrada');
    for_dados.tab_contas.Close;
  end;
end;

procedure Tfor_desp_parc.BitBtn1Click(Sender: TObject);
var
  dia, mes, ano : Word;
  data: tdate;
  c, par : integer;
  valor : real;
  pag, tipo : string;
begin
  DecodeDate(strtodate(MaskEdit1.Text),ano,mes,dia);
  par:=0;
  valor := strtofloat(edit4.Text);
  valor := valor * strtofloat(edit1.Text);
  memo1.Lines.Clear;
  if tiplanc = 's' then tipo := 'Saida';
  if tiplanc = 'e' then tipo := 'Entrada';
  for c:=1 to strtoint(edit1.Text) do
  begin
    par:= par+1;
    if par <> 1 then
    begin
      mes:=mes+1;
    end;
    if mes > 12 then
    begin
      mes:=1;
      ano:=ano+1;
    end;
    pag := inttostr(par)+'/'+ edit1.Text;
    data:= encodedate(ano,mes,dia);
    memo1.Lines.Add(pag+'    '+datetostr(data)+'    '+edit5.Text+'    '+edit4.Text+' '+tipo);
    with for_dados do
    begin
      tab_desp.Open;
      tab_desp.Insert;
      tab_despdes_situ.Value := 'a';
      tab_despdes_descr.Value := edit5.Text;
      tab_despdes_con.Value := strtoint(edit6.Text);
      tab_despdes_datlan.Value := date;
      tab_despdes_valor.Value := strtofloat(edit4.Text);
      tab_despdes_tipo.Value := tiplanc;
      tab_despdes_numpag.Value := pag;
      tab_despdes_datvenc.Value := data;
      if tiplanc = 'e' then
      begin
        tab_config.Open;
        tab_config.Edit;
        tab_configcod_rec.Value := tab_configcod_rec.Value + 1;
        tab_config.Post;
        tab_despdes_cod.Value := tab_configcod_rec.Value;
      end
      else
      begin
        tab_config.Open;
        tab_config.Edit;
        tab_configcod_pag.Value := tab_configcod_pag.Value + 1;
        tab_config.Post;
        tab_despdes_cod.Value := tab_configcod_pag.Value;
      end;
      tab_desp.Post;
      tab_desp.Close;
    end;
  end;
  memo1.Lines.Add('------------------------------------------------------');
  memo1.Lines.Add('Valor total => '+FloatToStrf(valor,ffcurrency,18,2));
  with for_dados do
  begin
    tab_contas.Open;
    IF (for_dados.tab_contas.Locate('con_cod',edit6.Text,[lopartialkey,locaseinsensitive])) = true then
    BEGIN
      tab_contas.Edit;
      if tiplanc = 'e' then
      begin
        tab_contasCon_credito.Value := tab_contasCon_credito.Value + valor;
      end
      else
      begin
        tab_contasCon_debito.Value := tab_contasCon_debito.Value + valor;
      end;
      tab_contas.Post;
      tab_contas.Close;
    end;
  end;
  showmessage('Lanamento realizado com sucesso');
  MaskEdit1.Text := datetostr(date);
end;

procedure Tfor_desp_parc.FormShow(Sender: TObject);
begin
  tiplanc := 'e';
  combobox1.Items.Clear;
  ComboBox1.Text := 'Tipo';
  ComboBox1.Items.Add('Entrada');
  ComboBox1.Items.Add('Saida');
  for_dados.tab_contas.Close;
  MaskEdit1.Text := datetostr(date);
  b_limpa.Click;
end;

procedure Tfor_desp_parc.MaskEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
  begin
    key := #0;
    Perform(CM_DIALOGKEY,vk_tab,0)
  end;
end;

procedure Tfor_desp_parc.b_limpaClick(Sender: TObject);
begin
  MaskEdit1.Text := datetostr(date);
  edit1.Clear;
  edit6.Text := '0';
  edit4.Text := '0,00';
  combobox1.Items.Clear;
  ComboBox1.Text := 'Tipo';
  ComboBox1.Items.Add('Entrada');
  ComboBox1.Items.Add('Saida');
  edit5.Clear;
  MEMO1.Lines.Clear;
  for_dados.tab_contas.Close;
end;

procedure Tfor_desp_parc.ComboBox1Change(Sender: TObject);
begin
  if ComboBox1.Text = 'Entrada' then tiplanc := 'e';
  if ComboBox1.Text = 'Saida' then tiplanc := 's';
end;

end.
