unit unt_rel_desp;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, DB, Grids, DBGrids, Buttons, Mask,
  Menus;

type
  Tfor_rel_desp = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ComboBox2: TComboBox;
    BitBtn1: TBitBtn;
    DBGrid1: TDBGrid;
    Panel2: TPanel;
    DataSource1: TDataSource;
    me_datini: TMaskEdit;
    me_datfim: TMaskEdit;
    DateTimePicker1: TDateTimePicker;
    DateTimePicker2: TDateTimePicker;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    PopupMenu1: TPopupMenu;
    Baixa1: TMenuItem;
    N1: TMenuItem;
    Editar1: TMenuItem;
    Label7: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    SpeedButton1: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure DateTimePicker1CloseUp(Sender: TObject);
    procedure DateTimePicker2CloseUp(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Baixa1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  for_rel_desp: Tfor_rel_desp;
  tipo, situ, tiprel : string;

implementation

uses unt_dados, unt_bai_desp, unt_contas;

{$R *.dfm}

procedure Tfor_rel_desp.FormShow(Sender: TObject);
begin
  combobox1.Items.Clear;
  ComboBox1.Text := 'Tipo';
  ComboBox1.Items.Add('Entrada');
  ComboBox1.Items.Add('Saida');
  combobox2.Items.Clear;
  combobox2.Text := 'Situao';
  ComboBox2.Items.Add('Abertas');
  ComboBox2.Items.Add('Comcluidas');
  ComboBox2.Items.Add('Canceladas');
  DateTimePicker1.date := date - 30;
  DateTimePicker2.Date := date;
  situ := 'a';
  tipo := 'e';
  me_datini.Text := datetostr(date - 30);
  me_datfim.Text := datetostr(date);
  label5.Caption := 'R$ 0,00';
  if tiprel = 'pd' then
  begin
    panel1.Height := 40;
    bitbtn1.Top := 6;
    label7.Visible := false;
    edit1.Visible := false;
    SpeedButton1.Visible := false;
    edit2.Visible := false;
  end
  else
  begin
    panel1.Height := 60;
    bitbtn1.Top := 30;
    label7.Visible := true;
    edit1.Visible := true;
    SpeedButton1.Visible := true;
    edit2.Visible := true;
    edit1.Clear;
    edit2.Clear;
  end;
end;

procedure Tfor_rel_desp.BitBtn1Click(Sender: TObject);
var
  valor : real;
begin
  with for_dados.que_desp do
  begin
    close;
    sql.Clear;
    sql.Add('select * from desp');
    sql.Add('where des_datvenc >= :vdat1 and des_datvenc <= :vdat2');
    sql.Add('and des_tipo = :vtipo and des_situ = :vsitu');
    if tiprel = 'pn' then
    begin
      sql.Add('and des_con = :vcon');
      parameters.ParamByName('vcon').Value := edit1.Text;
    end;
    sql.Add('order by des_datvenc');
    parameters.ParamByName('vdat1').Value := me_datini.Text;
    parameters.ParamByName('vdat2').value := me_datfim.Text;
    parameters.ParamByName('vtipo').Value := tipo;
    parameters.ParamByName('vsitu').Value := situ;
    open;
    First;
  end;
  valor := 0;
  with for_dados do
  begin
    while not que_desp.Eof do
    begin
      valor := valor + que_despdes_valor.AsVariant;
      que_desp.Next;
      label5.Caption := FloatToStrf(valor,ffcurrency,18,2);
    end;
  end;
  if for_dados.que_desp.IsEmpty = true then label5.Caption := 'R$ 0,00'
end;

procedure Tfor_rel_desp.ComboBox1Change(Sender: TObject);
begin
  if ComboBox1.Text = 'Entrada' then tipo := 'e';
  if ComboBox1.Text = 'Saida' then tipo := 's';
end;

procedure Tfor_rel_desp.ComboBox2Change(Sender: TObject);
begin
  if ComboBox2.Text = 'Abertas' then situ := 'a';
  if combobox2.Text = 'Comcluidas' then situ := 'co';
  if combobox2.Text = 'Canceladas' then situ := 'ca';
end;

procedure Tfor_rel_desp.DateTimePicker1CloseUp(Sender: TObject);
begin
  me_datini.Text := datetostr(DateTimePicker1.Date);
end;

procedure Tfor_rel_desp.DateTimePicker2CloseUp(Sender: TObject);
begin
  me_datfim.Text := datetostr(DateTimePicker2.Date);
end;

procedure Tfor_rel_desp.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  for_dados.que_desp.Close;
end;

procedure Tfor_rel_desp.Button1Click(Sender: TObject);
begin
  for_dados.que_desp.Edit;
  for_bai_desp.ShowModal;
end;

procedure Tfor_rel_desp.Baixa1Click(Sender: TObject);
begin
  button1.Click;
end;

procedure Tfor_rel_desp.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = vk_f1 then button1.Click;
  if key = vk_escape then close;
end;

procedure Tfor_rel_desp.SpeedButton1Click(Sender: TObject);
begin
  for_contas.ShowModal;
end;

procedure Tfor_rel_desp.Edit1Exit(Sender: TObject);
begin
  for_dados.tab_contas.Open;
  if edit1.Text <> '' then
  begin
    if (for_dados.tab_contas.Locate('con_cod',edit1.Text,[lopartialkey,locaseinsensitive]))=true then
    begin
      edit2.Text := for_dados.tab_contasCon_nome.Value;
    end
    else
    begin
      edit2.Clear;
      showmessage ('Conta no encontrada.');
    end;
    for_dados.tab_contas.Close;
  end;
end;

procedure Tfor_rel_desp.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if not ( Key In ['0'..'9',#13,#08] ) then
  Abort;
  if key = #13 then
  begin
    key := #0;
    Perform(CM_DIALOGKEY,vk_tab,0);
  end;
end;

end.
