unit unt_contas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, DBCtrls, Mask, DB;

type
  Tfor_contas = class(TForm)
    g1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    GroupBox1: TGroupBox;
    Label11: TLabel;
    Label10: TLabel;
    bsim: TButton;
    bnao: TButton;
    DBEdit10: TDBEdit;
    DBComboBox1: TDBComboBox;
    pmenu: TPanel;
    bavanca: TButton;
    bretornar: TButton;
    binclui: TButton;
    bmodifica: TButton;
    bexclui: TButton;
    Button1: TButton;
    DataSource1: TDataSource;
    DBEdit11: TDBEdit;
    DBEdit12: TDBEdit;
    Label13: TLabel;
    Label15: TLabel;
    procedure bincluiClick(Sender: TObject);
    procedure bnaoClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bsimClick(Sender: TObject);
    procedure DBComboBox1Exit(Sender: TObject);
    procedure DBEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure bavancaClick(Sender: TObject);
    procedure bretornarClick(Sender: TObject);
    procedure bmodificaClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure bexcluiClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  for_contas: Tfor_contas;
  situ : string;

implementation

uses unt_dados, unt_contas_bus;

{$R *.dfm}

function CPF(Num: String): Boolean;
var
  Temp: Integer;
  Numero: String;
  n: array [1..9] of Integer;
  d: array [1..2] of Integer;
begin
  Numero:='';
  for Temp:=1 to 14 do if Num[Temp] in ['0'..'9'] then Numero:=Numero+Num[Temp];
  for Temp:=1 to 9 do n[Temp]:=StrToInt(Numero[Temp]);
  d[1]:=n[9]*2+n[8]*3+n[7]*4+n[6]*5+n[5]*6+n[4]*7+n[3]*8+n[2]*9+n[1]*10;
  d[1]:=11-(d[1] mod 11);
  if d[1]>=10 then d[1]:=0;
  d[2]:=d[1]*2+n[9]*3+n[8]*4+n[7]*5+n[6]*6+n[5]*7+n[4]*8+n[3]*9+n[2]*10+n[1]*11;
  d[2]:=11-(d[2] mod 11);
  if d[2]>=10 then d[2]:=0;
  if IntToStr(d[1])+IntToStr(d[2])=Numero[10]+Numero[11] then CPF:=True else CPF:=False;
end;

function CGC(Num: String): Boolean;
var
  Temp: Integer;
  Numero: String;
  n: array [1..12] of Integer;
  d: array [1..2] of Integer;
begin
  Numero:='';
  for Temp:=1 to 18 do if Num[Temp] in ['0'..'9'] then Numero:=Numero+Num[Temp];
  for Temp:=1 to 12 do n[Temp]:=StrToInt(Numero[Temp]);
  d[1]:=n[12]*2+n[11]*3+n[10]*4+n[9]*5+n[8]*6+n[7]*7+n[6]*8+n[5]*9+n[4]*2+n[3]*3+n[2]*4+n[1]*5;
  d[1]:=11-(d[1] mod 11);
  if d[1]>=10 then d[1]:=0;
  d[2]:=d[1]*2+n[12]*3+n[11]*4+n[10]*5+n[9]*6+n[8]*7+n[7]*8+n[6]*9+n[5]*2+n[4]*3+n[3]*4+n[2]*5+n[1]*6;
  d[2]:=11-(d[2] mod 11);
  if d[2]>=10 then d[2]:=0;
  if IntToStr(d[1])+IntToStr(d[2])=Numero[13]+Numero[14] then CGC:=True else CGC:=False;
end;


procedure Tfor_contas.bincluiClick(Sender: TObject);
begin
   situ := 'i';
   bsim.Visible := true;
   bnao.Visible := true;
   g1.Enabled := true;
   pmenu.Enabled := false;
   with for_dados do
   begin
    tab_contas.Insert;
    tab_contasCon_data.Value := date;
    tab_config.Open;
    tab_contascon_cod.Value := tab_configcod_contas.Value + 1;
    tab_config.Close;
   end;
   dbedit1.SetFocus;
   label11.Caption := 'Deseja Incluir Cadastro';
end;

procedure Tfor_contas.bnaoClick(Sender: TObject);
begin
  for_dados.tab_contas.Cancel;
  situ := '';
  g1.Enabled;
  pmenu.Enabled := true;
  bavanca.SetFocus;
  bsim.Visible := false;
  bnao.Visible := false;
  label11.Caption := 'Tecle ESC para Sair';
end;

procedure Tfor_contas.FormShow(Sender: TObject);
begin
  with for_dados do
  begin
    tab_contas.Open;
  end;
end;

procedure Tfor_contas.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  with for_dados do
  begin
    tab_contas.Close;
  end;
end;

procedure Tfor_contas.bsimClick(Sender: TObject);
var
  lib : string;
begin
  if dbcombobox1.Text <> '' then
  begin
    if DBComboBox1.Text = 'Fsica' then
    begin
      if cpf(dbEdit7.Text)=false then
      begin
        ShowMessage('CPF Invlido');
        dbedit7.SetFocus;
        lib := 'n';
      end
    else
    begin
      lib := 's';
    end;
  end;

  if DBComboBox1.Text = 'Jurdica' then
  begin
   if CGC(dbEdit7.Text)=false then
   begin
    ShowMessage('CNPJ Invlido');
    dbedit7.SetFocus;
    lib := 'n';
   end
   else
   begin
    lib := 's';
   end;
   end;
  end;

  if (lib = 's') or (dbedit7.Text='') then
  begin
   with for_dados DO
   begin
    if situ ='i' then
    begin
      tab_config.Open;
      tab_config.Edit;
      tab_configcod_contas.Value := tab_configcod_contas.Value + 1;
      tab_contasCon_cod.Value := tab_configcod_contas.Value;
      tab_config.Post;
      tab_config.Close;
    end;
    tab_contas.Post;
   end;
   situ := '';
   g1.Enabled := false;
   bsim.Visible := false;
   bnao.Visible := false;
   pmenu.Enabled := true;
   bavanca.SetFocus;
   label11.Caption := 'Tecle ESC para Sair';
   for_dados.tab_contasCon_cgccpf.EditMask := '';
  end;
end;

procedure Tfor_contas.DBComboBox1Exit(Sender: TObject);
begin
  if DBComboBox1.Text = 'Jurdica' then
  begin
    for_dados.tab_contasCon_cgccpf.EditMask := '##.###.###/####-##;1;_';
  end
  else
  begin
    for_dados.tab_contasCon_cgccpf.EditMask := '###.###.###-##;1;_';
  end;
end;

procedure Tfor_contas.DBEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
  begin
    key := #0;
    Perform(CM_DIALOGKEY, vk_tab, 0)
  end;
end;

procedure Tfor_contas.bavancaClick(Sender: TObject);
begin
 with for_dados do
 begin
  tab_contas.Next;
  if tab_contas.Eof then showmessage('Fim, no pode avanar');
 end;
end;

procedure Tfor_contas.bretornarClick(Sender: TObject);
begin
  with for_Dados do
  begin
    tab_contas.Prior;
    if tab_contas.Bof then showmessage('Inicio, no pode voltar');
  end;
end;

procedure Tfor_contas.bmodificaClick(Sender: TObject);
begin
  situ := 'm';
  bsim.Visible := true;
  bnao.Visible := true;
  g1.Enabled := true;
  pmenu.Enabled := false;
  for_dados.tab_contas.Edit;
  dbedit1.SetFocus;
  bsim.Visible := true;
  bnao.Visible := true;
  g1.Enabled := true;
  pmenu.Enabled := false;
  dbedit1.SetFocus;
  label11.Caption := 'Salvar as Alteraoes';
end;

procedure Tfor_contas.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = vk_escape then
  begin
    if (situ='i') or (situ='m') then
    begin
      bnao.Click;
    end
    else
    begin
      close;
    end;
  end;
  if key = vk_f1 then
  begin
    BUTTON1.Click;
  end;
end;

procedure Tfor_contas.Button1Click(Sender: TObject);
begin
  for_contas_bus.ShowModal;
end;

procedure Tfor_contas.bexcluiClick(Sender: TObject);
begin
  for_dados.tab_contas.Delete;
end;

end.
