unit unt_menu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ToolWin, ActnMan, ActnCtrls, ActnMenus, XPStyleActnCtrls,
  ActnList;

type
  Tfor_menu = class(TForm)
    ActionManager1: TActionManager;
    ActionMainMenuBar1: TActionMainMenuBar;
    ac_contas: TAction;
    ac_desent: TAction;
    ac_dessaida: TAction;
    ac_rel_desp: TAction;
    ac_dep_parc: TAction;
    ac_config: TAction;
    ac_rel_dnome: TAction;
    procedure ac_contasExecute(Sender: TObject);
    procedure ac_desentExecute(Sender: TObject);
    procedure ac_dessaidaExecute(Sender: TObject);
    procedure ac_rel_despExecute(Sender: TObject);
    procedure ac_dep_parcExecute(Sender: TObject);
    procedure ac_configExecute(Sender: TObject);
    procedure ac_rel_dnomeExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  for_menu: Tfor_menu;

implementation

uses unt_contas, unt_desp_lanc, unt_rel_desp, unt_desp_parc, unt_config,
  unt_dados;

{$R *.dfm}

procedure Tfor_menu.ac_contasExecute(Sender: TObject);
begin
  for_contas.ShowModal;
end;

procedure Tfor_menu.ac_desentExecute(Sender: TObject);
begin
  unt_desp_lanc.tipdesp := 'e';
  with for_desp_lanc do
  begin
    panel1.Caption := 'Lanamentos de contas a receber.';
    ShowModal;
  end;
end;

procedure Tfor_menu.ac_dessaidaExecute(Sender: TObject);
begin
  unt_desp_lanc.tipdesp := 's';
  with for_desp_lanc do
  begin
    panel1.Caption := 'Lanamentos de contas a pagar.';
    ShowModal;
  end;
end;

procedure Tfor_menu.ac_rel_despExecute(Sender: TObject);
begin
  unt_rel_desp.tiprel := 'pd';
  for_rel_desp.ShowModal;
end;

procedure Tfor_menu.ac_dep_parcExecute(Sender: TObject);
begin
  for_desp_parc.ShowModal;
end;

procedure Tfor_menu.ac_configExecute(Sender: TObject);
begin
  for_config.ShowModal;
end;

procedure Tfor_menu.ac_rel_dnomeExecute(Sender: TObject);
begin
  unt_rel_desp.tiprel := 'pn';
  for_rel_desp.ShowModal;
end;

end.
